# TIL

Just try to record Today I Learned.

Inspired by [jbranchaud/til](https://github.com/jbranchaud/til)

## Categories

- [Data Structure](#data-structure)
- [GCP](#gcp)
- [Git](#git)
- [Golang](#golang)
- [JavaScript](#javascript)
- [Linux](#linux)
- [Markdown](#markdown)
- [MSSQL](#mssql)
- [MySQL](#mysql)
- [NestJS](#nestjs)
- [Network](#network)
- [Node.js](#nodejs)
- [OOP](#oop)
- [OS](#os)
- [PostgreSQL](#postgresql)
- [Redis](#redis)
- [Security](#security)
- [TypeScript](#typescript)
- [Unit Test](#unit-test)
- [VS Code](#vs-code)
- [Others](#others)

### Data Structure

- [遍歷 Binary Tree](./data-structure/traversal-binary-tree.md)

### GCP

- [macOS 安裝 gcloud](./gcp/macos-install-gcloud.md)

### Git

- [設定多個 remote repo](./git/set-multiple-remote-repo.md)
- [刪掉 remote 已經刪掉的 local branch](./git/delete-local-branch-deleted-at-remote.md)

### Golang

- [Swap](./golang/swap.md)
- [使用 gRPC 需安裝的相關東西](./golang/install-about-grpc.md)
- [如何寫 Benchmark](./golang/how-to-write-benchmark.md)
- [new vs make](./golang/new-vs-make.md)

### JavaScript

- [== vs ===](./javascript/double-equals-vs-triple-equals.md)
- [如何使用 Array 的 filter / find / map / reduce](./javascript/how-to-use-array-function-filter-find-map-reduce.md)
- [Destructuring 解構](./javascript/destructuring.md)
- [call / apply / bind](./javascript/call-apply-bind.md)
- [null / undefined / NaN](./javascript/null-undefined-NaN.md)
- [Object.assign()](./javascript/object-assign.md)
- [Reflect.set()](./javascript/reflect-set.md)
- [Object.entries()](./javascript/object-entries.md)
- [運算子](./javascript/operator.md)
- [Promise](./javascript/promise.md)
- [Turn string into number with positive sign](./javascript/turn-string-into-number-with-positive-sign.md)
- [Get HTML element's position](./javascript/get-html-element-position.md)
- [BOM](./javascript/bom.md)
- [Web 中使用 JS 的方式](./javascript/how-to-use-js-in-web.md)
- [DOM](./javascript/dom.md)
- [appendChild 使用](./javascript/using-appendChild.md)
- [innerHTML vs innerText](./javascript/innerHTML-vs-innerText.md)
- [監聽事件](./javascript/listening-event.md)
- [jQuery](./javascript/jQuery.md)

### Linux

- [將指令分段](./linux/separate-command.md)

### Markdown

- [Toggle](./markdown/toggle.md)

### MSSQL

- [在 SSMS 中確認 Log](./mssql/check-log-in-ssms.md)

### MySQL

- [unix time to readable time](./mysql/unixtime-to-readable-time.md)

### NestJS

- [Command](./nestjs/command.md)
- [Controller](./nestjs/controller.md)

### Network

- [HTTP & Socket & WebSocket](./network/http-socket-websocket.md)
- [TCP 與 UDP 的差異](./network/difference-between-tcp-udp.md)

### Node.js

- [Command](./nodejs/command.md)
- [監聽事件 process.on](./nodejs/process-on.md)
- [WSL 內安裝 Node.js](./nodejs/install-nodejs-in-wsl.md)
- [Commander.js](./nodejs/commander-js.md)

### OOP

- [什麼是 SOLID](./oop/what-is-solid.md)

### OS

- [Process & Thread & Coroutine](./os/process-thread-coroutine.md)

### PostgreSQL

- [SELECT ... FOR UPDATE](./postgresql/select-for-update.md)

### Redis

- [Redis 觀念](./redis/redis-concept.md)

### Security

- [SQL Injection 概念](./security/sql-injection-concept.md)
- [XSS 概念](./security/xss-concept.md)
- [CSRF 概念](./security/csrf-concept.md)

### TypeScript

- [Non-null assertion operator](./typescript/non-null-assertion-operator.md)
- [Pick & Record](./typescript/pick-and-record.md)
- [Any & Unknown](./typescript/any-and-unknown.md)
- [function 傳入參數的寫法](./typescript/another-way-to-pass-parameter-into-a-function.md)
- [Partial / Required type](./typescript/partial-required-type.md)
- [.d.ts file](./typescript/.d.ts-file.md)
- [用 VS Code 來 debug](./typescript/use-vscode-to-debug.md)
- [Decorator](./typescript/decorator.md)
- [class-validator: @IsOptional()](./typescript/@IsOptional.md)
- [Object literal lazy initial](./typescript/object-literal-lazy-initial.md)
- [Never](./typescript/never-type.md)
- [Compile with watch mode](./typescript/compile-with-watch-mode.md)
- [tsconfig](./typescript/tsconfig.md)
- [Override](./typescript/override.md)
- [Getter & Setter](./typescript/getter-and-setter.md)
- [Mapped Type](./typescript/mapped-type.md)

### Unit Test

- [Mocha and TypeScript](./unit-test/mocha-and-typescript.md)

### VS Code

- [設定 JS、TS 方法的括號自動補齊](./vscode/add-parentheses-when-autocompleting-function.md)
- [HTML template snippet](./vscode/html-template-snippet.md)

### Others

- [利用指令產生 ssh key file](./others/use-command-to-generate-ssh-key-file.md)
- [路徑中 \*\* 的意思](./others/star-sign-meaning-in-path.md)
