# Redis 概念

- 基於記憶體，響應時間約 100nm
- 資料結構類似 map，時間複雜度 O(1)
- 瓶頸通常是記憶體、網路頻寬
- 單一進程、單一執行緒

---

使用單一執行緒優點為

1. 省去 CPU context switch 切換
2. 不用去考慮 lock 的問題，沒有 lock、unlock、dead lock

---

IO 多路復用模型

- 假設我們有 30 個學生要檢查作業（30 個 request），有三種方法：

1. 一個老師站在第一個學生旁邊等他，確認完再到第二個那邊，以此類推，耗時最長
2. 找 30 個老師一個對一個學生，這樣速度最快，但最耗資源
3. 一個老師，學生好了就舉手，老師去檢查，CP 值最高

Redis 採用第三種方式實踐

---

處理過期策略

- 定期策略：有個 timer 去遍歷所有 key，看到過期的就刪除。缺點是遍歷很耗 CPU，且如果 key 已過期，但 timer 還沒遍歷到這個 key，會有還可以用的時間差。
- 惰性策略：取 key 時，先判斷該 key 過期了沒，過期則刪除。缺點為如果有 key 一直沒被用，就不會被刪除。

這兩種策略可以互補，定期策略去隨機抽查一部份 key，惰性策略則去檢查未抽查的 key，但可能還是有漏掉的，因此當記憶體不夠時還有`淘汰策略`。
