# .d.ts file

- 要在 TS 專案中使用 JS 的東西，就需要 `.d.ts` file 來協助

假設有一個 `module.js`，想要在 TS 使用

```jsx
const someNumber = 12;

function getArrayLength(arr) {
  return arr.length;
}

module.exports = {
  getArrayLength,
  someNumber,
};
```

需要建立一個 `module.d.ts`，寫法就是單純補上 type

```tsx
export const someNumber: 12;
export function getArrayLength(arr: any[]): number;
```

就可以在 TS 中 import 使用了

```tsx
import { getArrayLength, someNumber } from "./module";

console.log(getArrayLength([1, 2, 3]));

console.log(someNumber);
```
